﻿MarkerSafeEntregadorDeImoveis = createMarker( 915.407, -1235.156, 17.211, "cylinder", 120, 0, 255, 0, 0)

EntregadorDeImoveisPickup = createPickup ( 915.407, -1235.156, 17.211, 3, 1210)
MarkerEntregadorDeImoveis = createMarker ( 915.407, -1235.156, 17.211, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerEntregadorDeImoveis, EntregadorDeImoveisPickup, 0, 0, -1 )
BlipEntregadorDeImoveis = createBlipAttachedTo ( MarkerEntregadorDeImoveis, 42 )
setBlipVisibleDistance ( BlipEntregadorDeImoveis, 150 )

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", EntregadorDeImoveisPickup, CancelarSumirPickup )

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

local HQEntregadorDeImoveisBlip = createBlip ( 915.407, -1235.156, 17.211 )
setElementVisibleTo ( HQEntregadorDeImoveisBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQEntregadorDeImoveisBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador De Imoveis" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Entregador De Imoveis" then
	if isElementVisibleTo ( HQEntregadorDeImoveisBlip, source ) then
	setElementVisibleTo ( HQEntregadorDeImoveisBlip, source, false )
	exports.Scripts_Dxmessages:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQEntregadorDeImoveisBlip, source, true )
	exports.Scripts_Dxmessages:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Scripts_OnMarkerMsgs_:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "AirNew>Encaminhamento" ) == "Entregador De Imoveis" then
setElementData ( source, "AirNew>Encaminhamento", false )
setElementData ( source, "Emprego", "Entregador De Imoveis" )
exports.Scripts_Dxmessages:outputDx(source, "Você Agora Trabalha de Entregador De Imoveis, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Scripts_Dxmessages:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Scripts_OnMarkerMsgs_:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQEntregadorDeImoveisBlip, source ) then
setElementVisibleTo ( HQEntregadorDeImoveisBlip, source, false )
end
removeElementData ( source, "Emprego", "Entregador De Imoveis" )
exports.Scripts_Dxmessages:outputDx(source, "Você se Demitiu do Emprego de Entregador De Imoveis com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Entregador De Imoveis" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Entregador De Imoveis", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/Rotas #ffffff- #9ABDE0Abre a Lista de Rotas Disponiveis Para Trabalhar", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre no Caminhao e Digite /Rotas Selecione uma Rota e Siga os Checkpoints!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if isPedInVehicle ( source ) then return end
		if marker == MarkerEntregadorDeImoveis then
		    if getElementData ( source, "Emprego" ) == "Entregador De Imoveis" then
			exports.Scripts_OnMarkerMsgs_:create(source,"Aperte 'K' Para se Demitir do Emprego de Entregador De Imoveis")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Scripts_OnMarkerMsgs_:create(source,"Aperte 'K' Para Aceitar o Emprego de Entregador De Imoveis")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
	 end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerEntregadorDeImoveis then
			exports.Scripts_OnMarkerMsgs_:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

function CriarVeiculosComData ()
VeiculosComDataEntregadorDeImoveis = {
createVehicle(499, 900.902, -1208.861, 16.983, 0, 0, 180 ),
createVehicle(499, 868.514, -1206.461, 16.977, 0, 0, 180 ),
createVehicle(499, 831.841, -1209.684, 16.977, 0, 0, 180 ),
createVehicle(499, 867.91, -1243.8, 14.925, 0, 0, 270 ),
createVehicle(499, 866.53, -1254.321, 14.982, 0, 0, 270 ),


}

for i, veh in ipairs(VeiculosComDataEntregadorDeImoveis) do
setElementData ( veh, "Emprego", "Entregador De Imoveis" )
setVehicleDamageProof(veh,true)
setVehicleColor( veh, 0, 0, 0 )
setVehiclePlateText ( veh, "RPGAMING" )
addEventHandler("onVehicleStartEnter", veh, VerificarEmprego )
--addEventHandler("onVehicleExit", veh, SairDoVeiculosComData )
local tx, ty, tz = getElementPosition(veh)
local rx, ry, rz = getElementRotation(veh)
setVehicleRespawnPosition(veh, tx, ty, tz, rx, ry, rz)
end
end
addEventHandler("onResourceStart", resourceRoot, CriarVeiculosComData )

function VerificarEmprego (thePlayer, seat)
local Jogador = getElementData(thePlayer, "Emprego" )
if seat == 0 then
    if Jogador == "Entregador De Imoveis" then	
	else
    cancelEvent()
    exports.Scripts_Dxmessages:outputDx(thePlayer, "Esse Veiculo é Exclusivo dos Entregadores de Imoveis!", "error")
    end
  end
end

--[[function SairDoVeiculosComData ()
local veh = source
setTimer(function()
  if getVehicleOccupant(veh) == false then
respawnVehicle(veh)
end
end, 30000, 1)
end
addEventHandler ( "onPlayerQuit", getRootElement(), SairDoVeiculosComData ) --]]

--------------------------------------------------------------------

local rElement = getRootElement() 
  
function respawnVehicles(player, seconds)
    for i, veh in ipairs(VeiculosComDataEntregadorDeImoveis) do
        if isEmpty( veh ) then 
                respawnVehicle ( veh ) 
            end 
        end 
    end
setTimer(respawnVehicles, 60000,0)

function isEmpty( vehicle ) 
    local passengers = getVehicleMaxPassengers( vehicle ) 
    if type( passengers ) == 'number' then 
        for seat = 0, passengers do 
            if getVehicleOccupant( vehicle, seat ) then 
                return false 
            end 
        end 
    end 
    return true 
end

--------------------------------------------------------------------

atualrotnumberIMOVEIS = {}
ppcikIMOVEIS = {}
blips = {}

rotasIMOVEIS = {
	["Entregas de Imoveis - Los Santos (1) - 5 Entregas - $112000"] = {
		{1311.452, -922.079, 38.361},
		{1315.343, -1275.99, 13.383},
		{1055.472, -1286.386, 13.708},
		{335.357, -1517.874, 35.867},
		{1567.943, -1874.566, 13.383},
	},
	["Entregas de Imoveis - Los Santos (2) - 5 Entregas - $145000"] = {
		{1656.736, -1709.268, 20.484},
		{1975.386, -1571.312, 13.612},
		{2143.598, -1409.044, 24.446},
		{2171.021, -1006.285, 62.805},
		{1109.461, -1470.495, 15.797},
	},
	["Entregas de Imoveis - Los Santos (3) - 5 Entregas - $150000"] = {
		{974.266, -1534.736, 13.578},
		{786.476, -1632.994, 13.383},
		{1576.338, -2275.164, 13.304},
		{1714.712, -1881.295, 13.567},
		{1031.38, -889.841, 42.133},
	},
}

pay = {
	["Entregas de Imoveis - Los Santos (1) - 5 Entregas - $112000"] = 112000,
	["Entregas de Imoveis - Los Santos (2) - 5 Entregas - $145000"] = 145000,
	["Entregas de Imoveis - Los Santos (3) - 5 Entregas - $150000"] = 150000,
}

function ifPlayerEnterOnMarker(markerHit,matchingDimension)
	if isPedInVehicle(source) then
		if markerHit == ppcikIMOVEIS[source] then
			if (matchingDimension) then
				if isElement(ppcikIMOVEIS[source]) then
					local rname = getElementData(source,"rtnameImoveis") or nil
					if rname == nil then return end
					destroyElement(ppcikIMOVEIS[source])
					triggerClientEvent(source,"AirNew>JOBEntregadorDeImoveis>blips<Client",source,false)
					local vh = getPedOccupiedVehicle(source)
					
					toggleAllControls ( source, false )
					setControlState ( source, "handbrake", true )
					
					if atualrotnumberIMOVEIS[source] <= #rotasIMOVEIS[rname] then
					    exports.Scripts_Dxmessages:outputDx(source, "Entregando Imoveis... Aguarde 2 Segundos!", "info")
						setTimer(gerarrota,2500,1,source)
						setTimer(function(source) exports.Scripts_Dxmessages:outputDx(source, "Imoveis Entregues, Siga Para o Proximo Checkpoint!", "success") end,2500,1,source)
					elseif atualrotnumberIMOVEIS[source] == #rotasIMOVEIS[rname]+1 then
						setElementData(source,"rtnameImoveis",rname)
						atualrotnumberIMOVEIS[source] = 1
						local rec = pay[rname]
						givePlayerMoney(source,tonumber(rec))	
						local vh = getPedOccupiedVehicle(source)
						setTimer(function(source) exports.Scripts_Dxmessages:outputDx(source, "Você Recebeu um Valor de $"..rec.." Por Finalizar as Entregas de Imoveis!", "success") end,2500,1,source)
						setTimer(function(source) toggleAllControls ( source, true ) end, 2500,1, source )
						setTimer(function(source) setControlState ( source, "handbrake", false ) end, 2500,1, source )
						setElementData(source,"rtnameImoveis",nil)	
					end

					
				end

			end	
		end
	end
end
addEventHandler("onPlayerMarkerHit",getRootElement(),ifPlayerEnterOnMarker)

--------------------------------------------------------------------

function VerificarCairBike(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  local rname = getElementData(player,"rtnameImoveis") or nil
  if rname == nil then
  triggerClientEvent ( "Desligar:AntiQueda", player )
  else
  triggerClientEvent ( "Ligar:AntiQueda", player )
  end
 end		
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador De Imoveis" then
			   VerificarCairBike(pl)
			end
		end
	end
end,
3000,0)

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function pickjobImoveis(source)
	if not isElement(source) then return end
	local im = isPedInVehicle(source)
	if im == false then return end	
	local job = getElementData(source,"Emprego") or false
	if job == "Entregador De Imoveis" then
	local vh = getPedOccupiedVehicle(source)
	if isElement(vh) then
		local x,y = getElementPosition(vh)
		local x1,y1 = getElementPosition(source)
		local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
		local isMarkerSafe = isElementWithinMarker(vh,MarkerSafeEntregadorDeImoveis)
		local id = getElementModel(vh)
		local seat = getPedOccupiedVehicleSeat(source)
		if dist > 0 then return end
		if id == 499 then		
			if seat == 0 then
				if isMarkerSafe == false then return end
				triggerClientEvent(source,"AirNew>JOBEntregadorDeImoveis>AbrirPainel<Client",source,rotasIMOVEIS)
			end
		end
	end
end
end
addCommandHandler("rotas",pickjobImoveis)

function receivert(source,rotaname)
	if isElement(ppcikIMOVEIS[source]) then
		destroyElement(ppcikIMOVEIS[source])
	end	
	triggerClientEvent(source,"AirNew>JOBEntregadorDeImoveis>blips<Client",source,false)
	setElementData(source,"rtnameImoveis",rotaname)
	atualrotnumberIMOVEIS[source] = 1
	gerarrota(source)
end
addEvent("AirNew>request>Startrota>Server>EntregadorDeImoveis", true)
addEventHandler("AirNew>request>Startrota>Server>EntregadorDeImoveis",getRootElement(), receivert)

function gerarrota(source)
	local rname = getElementData(source,"rtnameImoveis") or nil
	if rname == nil then return end
	if not isElement(ppcikIMOVEIS[source]) and isPedInVehicle(source) then
		local vh = getPedOccupiedVehicle(source)
		toggleAllControls ( source, true )
		setControlState ( source, "handbrake", false )
		local id = tonumber(atualrotnumberIMOVEIS[source])
		local x,y,z = rotasIMOVEIS[rname][id][1],rotasIMOVEIS[rname][id][2],rotasIMOVEIS[rname][id][3]
		ppcikIMOVEIS[source] = createMarker (x, y,z, "checkpoint", 4, 255, 0, 0, 50,source)
		triggerClientEvent(source,"AirNew>JOBEntregadorDeImoveis>blips<Client",source,true,x,y,z)
		atualrotnumberIMOVEIS[source] = id+1
	end
end

function sair ( quitType )
	if isElement(ppcikIMOVEIS[source]) then
		destroyElement(ppcikIMOVEIS[source])
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

function SairDaBike ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtnameImoveis") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Scripts_Dxmessages:outputDx(thePlayer, "Você Saiu do caminhao, Entregas Canceladas!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDaBike )

function canceljobtimer(source)
	if isElement(ppcikIMOVEIS[source]) then
		destroyElement(ppcikIMOVEIS[source])
	end	
	triggerClientEvent(source,"AirNew>JOBEntregadorDeImoveis>blips<Client",source,false)	
	atualrotnumberIMOVEIS[source] = 1
	setElementData(source,"rtnameImoveis",nil)	
end

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Entregador De Imoveis" then return end
	local rname = getElementData(source,"rtnameImoveis") or nil
	if rname == nil then return end
	canceljobtimer(source)
	exports.Scripts_Dxmessages:outputDx(source, "Você Morreu e Suas Entregas Foram Canceladas!", "warning")
end	
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)