﻿MarkerSafeEntregadorDeEtanol = createMarker( -1320, 2699, 51, "cylinder", 100, 0, 255, 0, 0)

EntregadorDeEtanolPickup = createPickup ( -1320, 2699, 51, 3, 1210)
MarkerEntregadorDeEtanol = createMarker ( -1320, 2699, 51, "cylinder", 1.2, 255, 255, 255, 0 )
attachElements ( MarkerEntregadorDeEtanol, EntregadorDeEtanolPickup, 0, 0, -1 )
BlipEntregadorDeEtanol = createBlipAttachedTo ( MarkerEntregadorDeEtanol, 42 )
setBlipVisibleDistance ( BlipEntregadorDeEtanol, 150 )

function CancelarSumirPickup ( player )
   cancelEvent()
end
addEventHandler ( "onPickupHit", EntregadorDeEtanolPickup, CancelarSumirPickup )

LetraParaMarkers = "k"
cmd1 = "hq"
cmd2 = "profissao"

local HQEntregadorDeEtanolBlip = createBlip ( -1320, 2699, 51 )
setElementVisibleTo ( HQEntregadorDeEtanolBlip, root, false )

--------------------------------------------------------------------

function VerificarBlipEmprego(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  setElementVisibleTo ( HQEntregadorDeEtanolBlip, player, false )
  end
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador De Etanol" then return end
			   VerificarBlipEmprego(pl)
		end
	end
end,
3000,0)

--------------------------------------------------------------------

function ComandoHQ ( source )
    if getElementData ( source, "Emprego" ) == "Entregador De Etanol" then
	if isElementVisibleTo ( HQEntregadorDeEtanolBlip, source ) then
	setElementVisibleTo ( HQEntregadorDeEtanolBlip, source, false )
	exports.Scripts_Dxmessages:outputDx(source, "Seu Local de Trabalho foi Desmarcado do Mapa!", "info")
	else
	setElementVisibleTo ( HQEntregadorDeEtanolBlip, source, true )
	exports.Scripts_Dxmessages:outputDx(source, "Seu Local de Trabalho foi Marcado no Mapa!", "info")
end
end	
end    
addCommandHandler ( cmd1, ComandoHQ )

--------------------------------------------------------------------

function AceitarEmprego02 (source)
exports.Scripts_OnMarkerMsgs_:delete(source)
unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
if getElementData ( source, "AirNew>Encaminhamento" ) == "Entregador De Etanol" then
setElementData ( source, "AirNew>Encaminhamento", false )
setElementData ( source, "Emprego", "Entregador De Etanol" )
exports.Scripts_Dxmessages:outputDx(source, "Você Agora Trabalha de Entregador De Etanol, Para Mais Informações Digite ( /Profissao )", "success")
else
exports.Scripts_Dxmessages:outputDx(source, "Você Precisa Estar Encaminhado da Agencia de Empregos para Trabalhar neste Local!", "error")
end
end

function RecusarEmprego02 (source)
exports.Scripts_OnMarkerMsgs_:delete(source)
unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
if isElementVisibleTo ( HQEntregadorDeEtanolBlip, source ) then
setElementVisibleTo ( HQEntregadorDeEtanolBlip, source, false )
end
removeElementData ( source, "Emprego", "Entregador De Etanol" )
exports.Scripts_Dxmessages:outputDx(source, "Você se Demitiu do Emprego de Entregador De Etanol com Sucesso!", "warning")
end

--------------------------------------------------------------------

function ComandosProf ( ThePlayer )
if getElementData ( ThePlayer, "Emprego" ) == "Entregador De Etanol" then
playSoundFrontEnd ( ThePlayer, 43 )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #BEE09AComandos da Profissão de Entregador De Etanol", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/HQ #ffffff- #9ABDE0Para Marcar / Desmarcar o seu Local de Trabalho", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #55D444/Rotas #ffffff- #9ABDE0Abre a Lista de Rotas Disponiveis Para Trabalhar", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F96031» #FFD700Entre no Caminhao e Digite /Rotas Selecione uma Rota e Siga os Checkpoints!", ThePlayer, 255, 255, 255, true )
outputChatBox ( "#F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #F96031Profissão #F9A631~~~~~~~~~~~~~~~~~~~~~~~~~~~~", ThePlayer, 255, 255, 255, true )
end
end
addCommandHandler(cmd2, ComandosProf )

--------------------------------------------------------------------

function emarker(marker,md) 
	if (md) then
	  if isPedInVehicle ( source ) then return end
		if marker == MarkerEntregadorDeEtanol then
		    if getElementData ( source, "Emprego" ) == "Entregador De Etanol" then
			exports.Scripts_OnMarkerMsgs_:create(source,"Aperte 'K' Para se Demitir do Emprego de Entregador De Etanol")
			bindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		else
			exports.Scripts_OnMarkerMsgs_:create(source,"Aperte 'K' Para Aceitar o Emprego de Entregador De Etanol")
			bindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
		end
	 end
  end	
end
addEventHandler("onPlayerMarkerHit",getRootElement(),emarker)

function lmarker(marker,md)
	if (md) then
		if marker == MarkerEntregadorDeEtanol then
			exports.Scripts_OnMarkerMsgs_:delete(source)			
			unbindKey ( source, LetraParaMarkers, "down", AceitarEmprego02 )
			unbindKey ( source, LetraParaMarkers, "down", RecusarEmprego02 )
		end
	end
end
addEventHandler("onPlayerMarkerLeave",getRootElement(),lmarker)

function CriarVeiculosComData ()
VeiculosComDataEntregadorDeEtanol = {
createVehicle(578, -1288, 2714, 51, 0, 0, 180 ),
createVehicle(578, -1292, 2712, 51, 0, 0, 180 ),
createVehicle(578, -1296, 2710, 51, 0, 0, 180 ),
createVehicle(578, -1300, 2708, 51, 0, 0, 180 ),
createVehicle(578, -1304, 2706, 51, 0, 0, 180 ),

}

for i, veh in ipairs(VeiculosComDataEntregadorDeEtanol) do
setElementData ( veh, "Emprego", "Entregador De Etanol" )
setVehicleDamageProof(veh,true)
setVehicleColor( veh, 0, 0, 0 )
setVehiclePlateText ( veh, "RPGAMING" )
addEventHandler("onVehicleStartEnter", veh, VerificarEmprego )
--addEventHandler("onVehicleExit", veh, SairDoVeiculosComData )
local tx, ty, tz = getElementPosition(veh)
local rx, ry, rz = getElementRotation(veh)
setVehicleRespawnPosition(veh, tx, ty, tz, rx, ry, rz)
end
end
addEventHandler("onResourceStart", resourceRoot, CriarVeiculosComData )

function VerificarEmprego (thePlayer, seat)
local Jogador = getElementData(thePlayer, "Emprego" )
if seat == 0 then
    if Jogador == "Entregador De Etanol" then	
	else
    cancelEvent()
    exports.Scripts_Dxmessages:outputDx(thePlayer, "Esse Veiculo é Exclusivo dos Entregadores de Etanol!", "error")
    end
  end
end

--[[function SairDoVeiculosComData ()
local veh = source
setTimer(function()
  if getVehicleOccupant(veh) == false then
respawnVehicle(veh)
end
end, 30000, 1)
end
addEventHandler ( "onPlayerQuit", getRootElement(), SairDoVeiculosComData ) --]]

--------------------------------------------------------------------

local rElement = getRootElement() 
  
function respawnVehicles(player, seconds)
    for i, veh in ipairs(VeiculosComDataEntregadorDeEtanol) do
        if isEmpty( veh ) then 
                respawnVehicle ( veh ) 
            end 
        end 
    end
setTimer(respawnVehicles, 60000,0)

function isEmpty( vehicle ) 
    local passengers = getVehicleMaxPassengers( vehicle ) 
    if type( passengers ) == 'number' then 
        for seat = 0, passengers do 
            if getVehicleOccupant( vehicle, seat ) then 
                return false 
            end 
        end 
    end 
    return true 
end

--------------------------------------------------------------------

atualrotnumberETANOL = {}
ppcikETANOL = {}
blips = {}

rotasETANOL = {
	["ROTAS - (1) - 7 Paradas - $22500"] = {
		{-1515.6414794922,2536.2392578125,55.6875},
		{-1349.2156982422,2055.939453125,52.625076293945},
		{-1203.0886230469,1829.2286376953,41.71875},
		{-917.69781494141,2012.6779785156,60.9140625},
		{-773.88317871094,2087.4558105469,60.3828125},
		{-663.50207519531,2084.9499511719,60.3828125},
		{-306.36572265625,1525.8985595703,75.359375},
	},
	["ROTAS - (2) - 10 Paradas - $89000"] = {
		{-2416.0551757813,979.46771240234,45.296875},
		{-1670.6868896484,406.11218261719,7.1796875},
		{-2024.1246337891,172.14883422852,28.8359375},
		{-90.429641723633,-1192.7150878906,1.9987459182739},
		{1003.3306884766,-933.09490966797,42.1796875},
		{1941.2800292969,-1784.8623046875,13.390598297119},
		{2115.8703613281,938.15582275391,10.8203125},
		{2199.6267089844,2472.3154296875,10.8203125},
		{61.933952331543,1217.4582519531,18.840814590454},
		{-88.269752502441,1356.6529541016,10.301122665405},
	},
}

pay = {
	["ROTAS - (1) - 7 Paradas - $22500"] = 22500,
	["ROTAS - (2) - 10 Paradas - $89000"] = 89000,
}

function ifPlayerEnterOnMarker(markerHit,matchingDimension)
	if isPedInVehicle(source) then
		if markerHit == ppcikETANOL[source] then
			if (matchingDimension) then
				if isElement(ppcikETANOL[source]) then
					local rname = getElementData(source,"rtnameEtanol") or nil
					if rname == nil then return end
					destroyElement(ppcikETANOL[source])
					triggerClientEvent(source,"AirNew>JOBEntregadorDeEtanol>blips<Client",source,false)
					local vh = getPedOccupiedVehicle(source)
					
					toggleAllControls ( source, false )
					setControlState ( source, "handbrake", true )
					
					if atualrotnumberETANOL[source] <= #rotasETANOL[rname] then
					    exports.Scripts_Dxmessages:outputDx(source, "Liberando Etanol... Aguarde 1 Segundos!", "info")
						setTimer(gerarrota,1250,1,source)
						setTimer(function(source) exports.Scripts_Dxmessages:outputDx(source, "Etanol Entregue, Siga Para o Proximo Checkpoint!", "success") end,1250,1,source)
					elseif atualrotnumberETANOL[source] == #rotasETANOL[rname]+1 then
						setElementData(source,"rtnameEtanol",rname)
						atualrotnumberETANOL[source] = 1
						local rec = pay[rname]
						givePlayerMoney(source,tonumber(rec))	
						local vh = getPedOccupiedVehicle(source)
						setTimer(function(source) exports.Scripts_Dxmessages:outputDx(source, "Você Recebeu um Valor de $"..rec.." Por Finalizar as Entregas!", "success") end,1250,1,source)
						setTimer(function(source) toggleAllControls ( source, true ) end, 2500,1, source )
						setTimer(function(source) setControlState ( source, "handbrake", false ) end, 1250,1, source )
						setElementData(source,"rtnameEtanol",nil)	
					end

					
				end

			end	
		end
	end
end
addEventHandler("onPlayerMarkerHit",getRootElement(),ifPlayerEnterOnMarker)

--------------------------------------------------------------------

function VerificarCairBike(player)
  if player then
  acc = getPlayerAccount ( player )
  if isGuestAccount ( acc ) then return end
  local rname = getElementData(player,"rtnameEtanol") or nil
  if rname == nil then
  triggerClientEvent ( "Desligar:AntiQueda", player )
  else
  triggerClientEvent ( "Ligar:AntiQueda", player )
  end
 end		
end

setTimer(
function()
	for i, pl in pairs(getElementsByType("player")) do
		if pl ~= (false or nil) then
		    if getElementData ( pl, "Emprego" ) == "Entregador De Etanol" then
			   VerificarCairBike(pl)
			end
		end
	end
end,
3000,0)

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function pickjobEtanol(source)
	if not isElement(source) then return end
	local im = isPedInVehicle(source)
	if im == false then return end	
	local job = getElementData(source,"Emprego") or false
	if job == "Entregador De Etanol" then
	local vh = getPedOccupiedVehicle(source)
	if isElement(vh) then
		local x,y = getElementPosition(vh)
		local x1,y1 = getElementPosition(source)
		local dist = getDistanceBetweenPoints2D(x,y,x1,y1)
		local isMarkerSafe = isElementWithinMarker(vh,MarkerSafeEntregadorDeEtanol)
		local id = getElementModel(vh)
		local seat = getPedOccupiedVehicleSeat(source)
		if dist > 0 then return end
		if id == 578 then		
			if seat == 0 then
				if isMarkerSafe == false then return end
				triggerClientEvent(source,"AirNew>JOBEntregadorDeEtanol>AbrirPainel<Client",source,rotasETANOL)
			end
		end
	end
end
end
addCommandHandler("rotas",pickjobEtanol)

function receivert(source,rotaname)
	if isElement(ppcikETANOL[source]) then
		destroyElement(ppcikETANOL[source])
	end	
	triggerClientEvent(source,"AirNew>JOBEntregadorDeEtanol>blips<Client",source,false)
	setElementData(source,"rtnameEtanol",rotaname)
	atualrotnumberETANOL[source] = 1
	gerarrota(source)
end
addEvent("AirNew>request>Startrota>Server>EntregadorDeEtanol", true)
addEventHandler("AirNew>request>Startrota>Server>EntregadorDeEtanol",getRootElement(), receivert)

function gerarrota(source)
	local rname = getElementData(source,"rtnameEtanol") or nil
	if rname == nil then return end
	if not isElement(ppcikETANOL[source]) and isPedInVehicle(source) then
		local vh = getPedOccupiedVehicle(source)
		toggleAllControls ( source, true )
		setControlState ( source, "handbrake", false )
		local id = tonumber(atualrotnumberETANOL[source])
		local x,y,z = rotasETANOL[rname][id][1],rotasETANOL[rname][id][2],rotasETANOL[rname][id][3]
		ppcikETANOL[source] = createMarker (x, y,z, "checkpoint", 4, 255, 0, 0, 50,source)
		triggerClientEvent(source,"AirNew>JOBEntregadorDeEtanol>blips<Client",source,true,x,y,z)
		atualrotnumberETANOL[source] = id+1
	end
end

function sair ( quitType )
	if isElement(ppcikETANOL[source]) then
		destroyElement(ppcikETANOL[source])
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), sair )

function SairDaBike ( thePlayer, seat, jacked )
   local rname = getElementData(thePlayer,"rtnameEtanol") or nil
   if rname == nil then return end
   canceljobtimer (thePlayer)
   exports.Scripts_Dxmessages:outputDx(thePlayer, "Você Saiu da Bike, Entregas Canceladas!", "warning")
end
addEventHandler ( "onVehicleExit", getRootElement(), SairDaBike )

function canceljobtimer(source)
	if isElement(ppcikETANOL[source]) then
		destroyElement(ppcikETANOL[source])
	end	
	triggerClientEvent(source,"AirNew>JOBEntregadorDeEtanol>blips<Client",source,false)	
	atualrotnumberETANOL[source] = 1
	setElementData(source,"rtnameEtanol",nil)	
end

function canceljobdeath()
	local job = getElementData(source,"Emprego") or false
	if job ~= "Entregador De Etanol" then return end
	local rname = getElementData(source,"rtnameEtanol") or nil
	if rname == nil then return end
	canceljobtimer(source)
	exports.Scripts_Dxmessages:outputDx(source, "Você Morreu e Suas Entregas Foram Canceladas!", "warning")
end	
addEventHandler( "onPlayerWasted", getRootElement( ),canceljobdeath)